import { SerializedError } from "@reduxjs/toolkit";
import { FetchBaseQueryError } from "@reduxjs/toolkit/dist/query";
import * as React from "react";
import { UseQueryResult } from "./types";
declare type Props<T> = {
    query: UseQueryResult<T>;
    onSuccess: (data: T) => React.ReactElement;
    onError?: (error: FetchBaseQueryError | SerializedError) => React.ReactElement;
    onFetching?: React.ReactElement;
    whileFetching?: {
        append?: React.ReactElement;
        prepend?: React.ReactElement;
    };
    loader?: React.ReactElement;
};
export declare function RTKLoader<T>(props: Props<T>): React.ReactElement;
export {};
