"use strict";
exports.__esModule = true;
exports.RTKLoader = void 0;
var tslib_1 = require("tslib");
var React = (0, tslib_1.__importStar)(require("react"));
function RTKLoader(props) {
    var _a, _b, _c, _d, _e, _f, _g;
    var shouldLoad = props.query.isLoading || props.query.isUninitialized;
    var hasError = props.query.isError && props.query.error;
    var isFetching = props.query.isFetching;
    if (shouldLoad) {
        return (_a = props.loader) !== null && _a !== void 0 ? _a : React.createElement(React.Fragment, null);
    }
    if (hasError) {
        return ((_c = (_b = props.onError) === null || _b === void 0 ? void 0 : _b.call(props, props.query.error)) !== null && _c !== void 0 ? _c : (React.createElement(React.Fragment, null)));
    }
    if (isFetching && props.onFetching) {
        return props.onFetching;
    }
    if (props.query.data !== undefined) {
        var prepend = isFetching
            ? (_e = (_d = props.whileFetching) === null || _d === void 0 ? void 0 : _d.prepend) !== null && _e !== void 0 ? _e : null
            : null;
        var append = isFetching
            ? (_g = (_f = props.whileFetching) === null || _f === void 0 ? void 0 : _f.append) !== null && _g !== void 0 ? _g : null
            : null;
        var componentWithData = props.onSuccess(props.query.data);
        return (React.createElement(React.Fragment, null,
            prepend,
            componentWithData,
            append));
    }
    return React.createElement(React.Fragment, null);
}
exports.RTKLoader = RTKLoader;
//# sourceMappingURL=RTKLoader.js.map