import { __assign, __rest } from "tslib";
import { aggregateToQuery } from "./aggregateToQuery";
export var createUseLoader = function (createUseLoaderArgs) {
    var useLoader = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var createdQueries = createUseLoaderArgs.queries.apply(createUseLoaderArgs, args);
        var aggregatedQuery = aggregateToQuery(createdQueries);
        if (aggregatedQuery.isSuccess) {
            var data = createUseLoaderArgs.transform
                ? createUseLoaderArgs.transform(createdQueries)
                : createdQueries;
            return __assign(__assign({}, aggregatedQuery), { data: data, currentData: data, originalArgs: args });
        }
        return aggregatedQuery;
    };
    return useLoader;
};
export var createLoader = function (createLoaderArgs) {
    var _a;
    var useLoader = createUseLoader({
        queries: (_a = createLoaderArgs.queries) !== null && _a !== void 0 ? _a : (function () { return []; }),
        transform: createLoaderArgs.transform
    });
    var loader = {
        useLoader: useLoader,
        onLoading: createLoaderArgs.onLoading,
        onError: createLoaderArgs.onError,
        onFetching: createLoaderArgs.onFetching,
        whileFetching: createLoaderArgs.whileFetching,
        queriesArg: createLoaderArgs.queriesArg,
        extend: function (_a) {
            var queries = _a.queries, transform = _a.transform, loaderArgs = __rest(_a, ["queries", "transform"]);
            var extendedLoader = __assign(__assign({}, this), loaderArgs);
            if (queries) {
                var newUseLoader = createUseLoader({
                    queries: queries,
                    transform: transform
                });
                extendedLoader.useLoader = newUseLoader;
            }
            return extendedLoader;
        }
    };
    return loader;
};
//# sourceMappingURL=createLoader.js.map