import { __assign } from "tslib";
import React from "react";
import { RTKLoader } from "./RTKLoader";
export var withLoader = function (Component, args) {
    var CachedComponent;
    var LoaderComponent = function (props) {
        var _a, _b, _c, _d, _e, _f;
        var useLoaderArgs = [];
        if (args.queriesArg) {
            useLoaderArgs.push(args.queriesArg(props));
        }
        var query = args.useLoader.apply(args, useLoaderArgs);
        if (!CachedComponent) {
            CachedComponent = React.forwardRef(Component);
        }
        var onLoading = (_a = args.onLoading) === null || _a === void 0 ? void 0 : _a.call(args, props);
        var onError = args.onError
            ? function (error) {
                if (!args.onError)
                    return React.createElement(React.Fragment, null);
                return args.onError(props, error, query);
            }
            : undefined;
        var onSuccess = function (data) { return (React.createElement(CachedComponent, __assign({}, props, { ref: data }))); };
        var whileFetching = args.whileFetching
            ? {
                prepend: (_c = (_b = args.whileFetching).prepend) === null || _c === void 0 ? void 0 : _c.call(_b, props, query === null || query === void 0 ? void 0 : query.data),
                append: (_e = (_d = args.whileFetching).append) === null || _e === void 0 ? void 0 : _e.call(_d, props, query === null || query === void 0 ? void 0 : query.data)
            }
            : undefined;
        var onFetching = (_f = args === null || args === void 0 ? void 0 : args.onFetching) === null || _f === void 0 ? void 0 : _f.call(args, props, query.data
            ? function () { return onSuccess(query.data); }
            : function () { return React.createElement(React.Fragment, null); });
        return (React.createElement(RTKLoader, { query: query, onSuccess: onSuccess, onError: onError, loader: onLoading, onFetching: onFetching, whileFetching: whileFetching }));
    };
    return LoaderComponent;
};
//# sourceMappingURL=withLoader.js.map